'// Original PowerBASIC "Address" DDT Project,
'// translated to plain SDK flat API 
'// Created by Patrice TERRIER on november 30, 2014
'// Last revision december 10, 2014

#COMPILE EXE "DPIaddress.exe"
#INCLUDE "SDKaddress.inc"
#RESOURCE "zap.pbr"

'#INCLUDE "WINLIFT.INC"
declare function zTrace lib "zTrace.DLL" alias "zTrace" (zMessage as asciiz) as long

%ID_INDEX      = 100
%ID_COMPANY    = 101
%ID_LASTNAME   = 102
%ID_FIRSTNAME  = 103
%ID_ADDRESS1   = 104
%ID_ADDRESS2   = 105
%ID_ADDRESS3   = 106
%ID_CITYNAME   = 107
%ID_STATENAME  = 108
%ID_ZIPCODE    = 109
%ID_COUNTRY    = 110
%ID_PHONE      = 111
%ID_FAX        = 112
%ID_EMAIL      = 113
%ID_URL        = 114
%ID_COMMENTS   = 115

%ID_PRIOR      = 121
%ID_NEXT       = 122
%ID_ADD        = 123
%ID_UPDATE     = 124
%ID_FIND       = 125
%ID_DELETE     = 126
%ID_PRINT      = 127

%ID_MENU_CLOSE = %IDCANCEL
%ID_MENU_CUT   = 201
%ID_MENU_COPY  = 202
%ID_MENU_PASTE = 203
%ID_MENU_HELP  = 204
%ID_MENU_ABOUT = 205

%WM_APPLYFOCUS = %WM_USER + 999

type AddressType BYTE
    Company   as string * 64
    LastName  as string * 32
    FirstName as string * 32
    Address1  as string * 64
    Address2  as string * 64
    Address3  as string * 64
    CityName  as string * 24
    StateName as string * 4
    ZipCode   as string * 12
    Country   as long
    Phone     as string * 24
    Fax       as string * 24
    Email     as string * 64
    Url       as string * 64
    Comments  as string * 1024
end type

type PROP
    usefont        as dword
    hinstance      as dword
    isrecmodified  as long
    isfilemodified as long
    currententry   as long
    maxentries     as long
    findtext       as asciiz * %MAX_PATH
end type

global gP as PROP, gAddressBook() as AddressType

function dpi(byval nPix as long) as long
    static ratio as single
    if (ratio = 0) then
        local hDC as DWORD
        hDC = GetDC(%NULL): ratio = (GetDeviceCaps(hDC, %LOGPIXELSX) / 96): ReleaseDC(%NULL, hDC)   
    end if
    function = clng(nPix * ratio)
end function

function addLabel(byval hParent as dword, byval nID as long, zCaption as asciiz, byval x as long, byval y as long, byval w as long, byval h as long, byval dwStyle as dword) as dword
    local hCtrl as dword
    hCtrl = CreateWindowEx(0, "Static", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, nID, gP.hinstance, byval %NULL)
    if hCtrl then SendMessage(hCtrl, %WM_SETFONT, gP.usefont, 0)
    function = hCtrl
end function

function addTextBox(byval hParent as dword, byval nID as long, zCaption as asciiz, byval x as long, byval y as long, byval w as long, byval h as long, byval dwStyle as dword) as dword
    local hCtrl as dword
    hCtrl = CreateWindowEx(%WS_EX_CLIENTEDGE, "Edit", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, nID, gP.hinstance, byval %NULL)
    if hCtrl then SendMessage(hCtrl, %WM_SETFONT, gP.usefont, 0)
    function = hCtrl
end function

function addComboBox(byval hParent as dword, byval nID as long, zCaption as asciiz, byval x as long, byval y as long, byval w as long, byval h as long, byval dwStyle as dword) as dword
    local hCtrl as dword
    hCtrl = CreateWindowEx(0, "ComboBox", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, nID, gP.hinstance, byval %NULL)
    if hCtrl then SendMessage(hCtrl, %WM_SETFONT, gP.usefont, 0)
    function = hCtrl
end function

function addButton(byval hParent as dword, byval nID as long, zCaption as asciiz, byval x as long, byval y as long, byval w as long, byval h as long, byval dwStyle as dword) as dword
    local hCtrl as dword
    hCtrl = CreateWindowEx(0, "Button", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, nID, gP.hinstance, byval %NULL)
    if hCtrl then SendMessage(hCtrl, %WM_SETFONT, gP.usefont, 0)
    function = hCtrl
end function

sub AddCountries(BYVAL hCtrl as dword)
    local K as long, sCountry as string, zItem as asciiz * 32
    sCountry = "United States,Afghanistan,Albania,Algeria,Andorra,Angola,Anguilla" + _
    ",Antarctica,Argentina,Armenia,Aruba,Australia,Austria" + _
    ",Azerbaijan,Bahamas,Bahrain,Bangladesh,Barbados,Belarus" + _
    ",Belgium,Belize,Benin,Bermuda,Bhutan,Bolivia,Botswana" + _
    ",Bouvet Island,BosniaHerzogovina,Brazil,Brunei,Bulgaria" + _
    ",Burkina Faso,Cambodia,Cameroon,Canada,Cape Verde" + _
    ",Cayman Islands,Central African Rep,Chad,Chile,China" + _
    ",Christmas Island,Colombia,Comoros,Congo,Cook Islands" + _
    ",Costa Rica,Croatia,Cuba,Cyprus,Czech Republic,Denmark" + _
    ",Djibouti,Dominica,Dominican Republic,East Timor,Ecuador" + _
    ",Egypt,El Salvador,Equatorial Guinea,Eritrea,Estonia" + _
    ",Ethiopia,Falkland Islands,Faroe Islands,Fiji,Finland" + _
    ",France,France Metropolitan,French Guiana,French Polynesia" + _
    ",French S. Territories,Gabon,Gambia,Georgia,Germany,Ghana" + _
    ",Gibraltar,Greece,Greenland,Grenada,Guadeloupe,Guam" + _
    ",Guatemala,Guinea,Guinea-Bissau,Guyana,Haiti,Honduras" + _
    ",Hong Kong,Hungary,Iceland,IN India,Indonesia,Iran,Iraq" + _
    ",Ireland,Israel,Italy,Ivory Coast,Jamaica,Japan,Jordan" + _
    ",Kazakhstan,Kenya,Kiribati,Korea (North),Korea (South)" + _
    ",Kuwait,Kyrgyzstan,Laos,Latvia,Lebanon,Lesotho,Liberia" + _
    ",Libya,Liechtenstein,Lithuania,Luxembourg,Macau,Macedonia" + _
    ",Madagascar,Malawi,Malaysia,Maldives,Mali,Malta" + _
    ",Marshall Islands,Martinique,Mauritania,Mauritius,Mayotte" + _
    ",Mexico,Micronesia,Miquelon,Moldova,Monaco,Mongolia,Montserrat" + _
    ",Morocco,Mozambique,Myanmar,Namibia,Nauru,Nepal" + _
    ",Netherlands,Nevis,New Caledonia,New Guinea,New Zealand" + _
    ",Nicaragua,Niger,Nigeria,Niue,Norfolk Island,Norway" + _
    ",Oman,Pakistan,Palau,Panama,Paraguay,Peru,Philippines" + _
    ",Pitcairn,Poland,Portugal,Principe,Puerto Rico,Qatar" + _
    ",Reunion,Romania,Russian Federation,Rwanda,Saint Kitts" + _
    ",Saint Lucia,Samoa,San Marino,Sao Tome,Saudi Arabia,Senegal" + _
    ",Seychelles,Sierra Leone,Singapore,Slovak Republic,Slovenia" + _
    ",Solomon Islands,Somalia,South Africa,Spain,Sri Lanka" + _
    ",St. Helena,St. Pierre,Sudan,Suriname,Swaziland,Sweden" + _
    ",Switzerland,Syria,Taiwan,Tajikistan,Tanzania,Thailand" + _
    ",Tobago,Togo,Tokelau,Tonga,Trinidad,Tunisia,Turkey" + _
    ",Turkmenistan,Tuvalu,Uganda,Ukraine,United Arab Emirates" + _
    ",United Kingdom,United States,Uruguay,Uzbekistan,Vanuatu" + _
    ",Vatican City State,Venezuela,Viet Nam,Virgin Islands (BR)" + _
    ",Virgin Islands (US),Western Sahara,Yemen,Yugoslavia,Zaire" + _
    ",Zambia,Zimbabwe,Other"
    for K = 1 to PARSECOUNT(sCountry)
        zItem = PARSE$(sCountry, K): SendMessage(hCtrl, %CB_ADDSTRING, 0, varptr(zItem))
    next
end sub

function FileSize(szFileSpec as asciiz) as dword
    local fd as WIN32_FIND_DATA
    local nRet, hFind as DWORD
    if (len(szFileSpec)) then
        hFind = FindFirstFile(szFileSpec, fd)
        if (hFind <> %INVALID_HANDLE_VALUE) then
            FindClose(hFind)
            nRet = fd.nFileSizeLow
        end if
    end if
    function = nRet
end function

sub SetButtonStatus(byval hWnd as dword)

    '// If any current text is modified, make the ADD & Update buttons active
    if (gP.isrecmodified) then
        EnableWindow(GetDlgItem(hWnd, %ID_ADD), %TRUE)
        EnableWindow(GetDlgItem(hWnd, %ID_UPDATE), %TRUE)
    else
        EnableWindow(GetDlgItem(hWnd, %ID_ADD), %FALSE)
        EnableWindow(GetDlgItem(hWnd, %ID_UPDATE), %FALSE)
    end if

    '// Update the Index control text
    SetWindowText(GetDlgItem(hWnd, %ID_INDEX), str$(gP.currententry) + " /" + str$(gP.maxentries))

    '// Do we have any records? is not, disable the Prior/Next buttons, etc
    if (gP.maxentries) then
        '// If there are records, allow the Find/Delete buttons
        EnableWindow(GetDlgItem(hWnd, %ID_FIND), %TRUE)
        EnableWindow(GetDlgItem(hWnd, %ID_DELETE), %TRUE)

        '// We have records, so set the Prior button status according to the current index position
        if (gP.currententry < 2) then
            EnableWindow(GetDlgItem(hWnd, %ID_PRIOR), %FALSE)
        else
            EnableWindow(GetDlgItem(hWnd, %ID_PRIOR), %TRUE)
        end if
        '// Update the Next control button
        if (gP.currententry >= gP.maxentries) then
            EnableWindow(GetDlgItem(hWnd, %ID_NEXT), %FALSE)
        else
            EnableWindow(GetDlgItem(hWnd, %ID_NEXT), %TRUE)
        end if
    else
        EnableWindow(GetDlgItem(hWnd, %ID_PRIOR), %FALSE)
        EnableWindow(GetDlgItem(hWnd, %ID_NEXT), %FALSE)
        EnableWindow(GetDlgItem(hWnd, %ID_FIND), %FALSE)
        EnableWindow(GetDlgItem(hWnd, %ID_DELETE), %FALSE)
    end if
end sub

sub UdtToDialog(byval hWnd as DWORD, byval Index as long)

    local Temp as AddressType, SaveState as long

    if Index > UBOUND(gAddressBook(1)) or Index < LBOUND(gAddressBook(1)) then
       RESET Temp
    else
       Temp = gAddressBook(Index)
    end if

    '// When we change the edit control data, we generate EN_UPDATE messages...
    '// Due to the design of our GUI interface, we would end up with the ADD and UPDATE
    '// buttons becoming enabled just because we loaded a new UDT record into the dialog.
    '// to overcome this, we set the "modified" flag to %TRUE, so the main callback
    '// function ingores the "update" notication messages.

    SaveState = gP.isrecmodified
    gP.isrecmodified = %TRUE

    SetWindowText(GetDlgItem(hWnd, %ID_COMPANY),   rtrim$(Temp.Company))
    SetWindowText(GetDlgItem(hWnd, %ID_LASTNAME),  rtrim$(Temp.LastName))
    SetWindowText(GetDlgItem(hWnd, %ID_FIRSTNAME), rtrim$(Temp.FirstName))
    SetWindowText(GetDlgItem(hWnd, %ID_ADDRESS1),  rtrim$(Temp.Address1))
    SetWindowText(GetDlgItem(hWnd, %ID_ADDRESS2),  rtrim$(Temp.Address2))
    SetWindowText(GetDlgItem(hWnd, %ID_ADDRESS3),  rtrim$(Temp.Address3))
    SetWindowText(GetDlgItem(hWnd, %ID_CITYNAME),  rtrim$(Temp.CityName))
    SetWindowText(GetDlgItem(hWnd, %ID_STATENAME), rtrim$(Temp.StateName))
    SetWindowText(GetDlgItem(hWnd, %ID_ZIPCODE),   rtrim$(Temp.ZipCode))
    SendMessage  (GetDlgItem(hWnd, %ID_COUNTRY),   %CB_SETCURSEL, Temp.Country - 1, 0)
    SetWindowText(GetDlgItem(hWnd, %ID_PHONE),     rtrim$(Temp.Phone))
    SetWindowText(GetDlgItem(hWnd, %ID_FAX),       rtrim$(Temp.Fax))
    SetWindowText(GetDlgItem(hWnd, %ID_EMAIL),     rtrim$(Temp.Email))
    SetWindowText(GetDlgItem(hWnd, %ID_URL),       rtrim$(Temp.Url))
    SetWindowText(GetDlgItem(hWnd, %ID_COMMENTS),  rtrim$(Temp.Comments))

    '// Restore the previous state
    gP.isrecmodified = SaveState
end sub

sub DialogToUdt (byval hWnd as dword, byval Index as long)
    local Temp as AddressType
    if (Index > 0 and Index < UBOUND(gAddressBook(1)) + 1) then
        Temp = gAddressBook(Index)
        GetWindowText(GetDlgItem(hWnd, %ID_COMPANY), byval varptr(Temp.Company), sizeof(Temp.Company))
        GetWindowText(GetDlgItem(hWnd, %ID_LASTNAME), byval varptr(Temp.LastName), sizeof(Temp.LastName))
        GetWindowText(GetDlgItem(hWnd, %ID_FIRSTNAME), byval varptr(Temp.FirstName), sizeof(Temp.FirstName))
        GetWindowText(GetDlgItem(hWnd, %ID_ADDRESS1), byval varptr(Temp.Address1), sizeof(Temp.Address1))
        GetWindowText(GetDlgItem(hWnd, %ID_ADDRESS2), byval varptr(Temp.Address2), sizeof(Temp.Address2))
        GetWindowText(GetDlgItem(hWnd, %ID_ADDRESS3), byval varptr(Temp.Address3), sizeof(Temp.Address3))
        GetWindowText(GetDlgItem(hWnd, %ID_CITYNAME), byval varptr(Temp.CityName), sizeof(Temp.CityName))
        GetWindowText(GetDlgItem(hWnd, %ID_STATENAME), byval varptr(Temp.StateName), sizeof(Temp.StateName))
        GetWindowText(GetDlgItem(hWnd, %ID_ZIPCODE), byval varptr(Temp.ZipCode), sizeof(Temp.ZipCode))
        Temp.Country = SendMessage(GetDlgItem(hWnd, %ID_COUNTRY), %CB_GETCURSEL, 0, 0) + 1
        GetWindowText(GetDlgItem(hWnd, %ID_PHONE), byval varptr(Temp.Phone), sizeof(Temp.Phone))
        GetWindowText(GetDlgItem(hWnd, %ID_FAX), byval varptr(Temp.Fax), sizeof(Temp.Fax))
        GetWindowText(GetDlgItem(hWnd, %ID_EMAIL), byval varptr(Temp.Email), sizeof(Temp.Email))
        GetWindowText(GetDlgItem(hWnd, %ID_URL), byval varptr(Temp.Url), sizeof(Temp.Url))
        GetWindowText(GetDlgItem(hWnd, %ID_COMMENTS), byval varptr(Temp.Comments), sizeof(Temp.Comments))

        gAddressBook(Index) = Temp
    end if
end sub

function AddUpdateRecord (byval hWnd as dword, byval wParam as dword) as long

    '// This function is only called if gP.isrecmodified is %TRUE
    local LastName as string, Temp as AddressType

    '// Get the Last Name field
    LastName = space$(sizeof(Temp.LastName))
    GetWindowText(GetDlgItem(hWnd, %ID_LASTNAME), byval strptr(LastName), sizeof(Temp.LastName))
    LastName = rtrim$(LastName, any chr$(0,32))

    '// Check if Last Name entered; at this stage will not check for duplicate entries
    if (len(LastName) = 0) then
        '// Display error message dialog
        MessageBox(hWnd, "You must specify a Last Name!", "", %MB_ICONEXCLAMATION)
        '// Move focus to the offending control
        SetFocus(GetDlgItem(hWnd, %ID_LASTNAME))
        exit function
    end if

    '// Now determine if ADD or UPDATE buttons clicked
    if (lo(word, wParam) = %ID_ADD or gP.maxentries < 1) then '// It's the Add button, or we have no existing entries
        '// Extend the UDT array and insert the new address data
        incr gP.maxentries
        gP.currententry = gP.maxentries
        redim preserve gAddressBook(1 to gP.maxentries) as global AddressType
    else   '// It's the update button
        '// Simply update the existing record
    end if

    '// Get the data from the dialog
    DialogToUdt(hWnd, gP.currententry)

    '// Reset the modified flag
    gP.isrecmodified = %FALSE

    '// Flag data as modified
    gP.isfilemodified = %TRUE

    '// Update the dialog controls
    SetButtonStatus(hWnd)

end function

sub DeleteRecord (byval hWnd as dword)

    '// Only permit a deletion if the index is valid
    if (gP.currententry < 1 or gP.currententry > gP.maxentries) then exit sub

    '// Confirm deletion
    if (MessageBox(hWnd, "Are you sure you want to delete this record?", _
                   "Delete Record", %MB_ICONQUESTION or %MB_OKCANCEL) = %IDCANCEL) then exit sub

    '// Now perform the removal of the record and update our index variables
    array delete gAddressBook(gP.currententry)
    decr gP.maxentries
    gP.currententry = min&(gP.currententry, gP.maxentries)
    redim preserve gAddressBook(1 to max&(1, gP.maxentries)) as global AddressType

    '// Update our status flags & refresh the window
    gP.isrecmodified = %FALSE
    gP.isfilemodified = %TRUE
    SetButtonStatus(hWnd)
    UdtToDialog(hWnd, gP.currententry)

end sub

function FindDialogProc (byval hWnd as dword, byval uMsg as dword, byval wParam as dword, byval lParam as long) as long
    local K as long, hParent as dword, sFindText as string

    select case long (uMsg)
    case %WM_COMMAND
         select case lo(word, wParam)
         case %IDCANCEL
              if (hi(word, wParam) = %BN_CLICKED) then
                  SendMessage(hWnd, %WM_CLOSE, 0, 0)
                  exit function
              end if
         case %ID_FIND
               '// Retrieve the search text if the edit control contents change.
               '// We save it in a global string variable so we can recreate the
               '// Find dialog with the same search text if it is relaunched again.
               if (hi(word, wParam) = %EN_UPDATE) then  '// The text was changed
                   '// Get the text and trim away eventual leading/trailing spaces
                   GetWindowText(GetDlgItem(hWnd, %ID_FIND), gP.findtext, sizeof(gP.findtext))
                   gP.findtext = TRIM$(gP.findtext)
               end if
               exit function
         case %IDOK  '// Ok button
               '// Now initiate a search as long as the search text is available
               if ((hi(word, wParam) = %BN_CLICKED) and (len(gP.findtext))) then
                   '// Get main dialog handle
                   hParent = GetParent(hWnd)
                   '// Start search from next record and loop from end to start
                   sFindText = ucase$(gP.findtext)
                   for K = gP.currententry + 1 to gP.maxentries
                       if (instr(ucase$(gAddressBook(K)), sFindText)) then
                           gP.isrecmodified = %FALSE
                           gP.currententry = K
                           UdtToDialog(hParent, gP.currententry)
                           SetButtonStatus(hParent)
                           exit function
                      end if
                   next

                   '// No match between index and end, so restart from beginning of file
                   for K = 1 to gP.currententry
                       if (instr(ucase$(gAddressBook(K)), sFindText)) then
                           gP.isrecmodified = %FALSE
                           gP.currententry = K
                           UdtToDialog(hParent, gP.currententry)
                           SetButtonStatus(hParent)
                           exit function
                       end if
                   next
                   '// Hmmm... no matches at all!
                   '// By disabling the Modeless Find dialog while the MSGBOX is shown,
                   '// we ensure the parent dialog keeps its zOrder and regains focus
                   '// when the Find dialog is closed, else Windows may lose track of
                   '// it and send it to the back..
                   EnableWindow(hWnd, %FALSE)
                   MessageBox(hParent, "Find record", "No occurrences found.", %MB_ICONERROR or %MB_TASKMODAL)
                   EnableWindow(hWnd, %TRUE)
               end if
               exit function
         end select

    case %WM_DESTROY
         EnableWindow(GetParent(hWnd), 1)
         '// Close the main window
         PostQuitMessage(0)
         exit function
    end select

    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

function FindDialog (byval hParent as dword) as long

    LOCAL x, y, w, h, K, nWidth, nHeight, IsInitialized as long
    local hWnd, hCtrl, hGFI as DWORD
    LOCAL wcx AS WndClassEx, zClass AS ASCIIZ * 16
    LOCAL msg AS tagMsg, rc, rw AS RECT
    LOCAL dwStyle, dwExStyle as dword

    zClass = "TOOLFIND"
    wcx.cbSize = SIZEOF(wcx)
    IsInitialized = GetClassInfoEx(gP.hInstance, zClass, wcx)
    if (IsInitialized     = 0) then
        wcx.style         = 0
        wcx.lpfnWndProc   = codeptr(FindDialogProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = gP.hInstance
        wcx.hIcon         = %NULL
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %COLOR_BTNSHADOW
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = VARPTR(zClass)
        wcx.hIconSm       = wcx.hIcon
        if (RegisterClassEx(wcx)) then IsInitialized = %TRUE
    end if

    if (IsInitialized) then

        SetRect(rc, 0, 0, dpi(231), dpi(112))
        '// Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
        '// but it won't hurt anything to keep it, in case we change our mind ;)
        dwStyle = %WS_POPUP or %WS_CAPTION or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN or %WS_SYSMENU
        dwExStyle = %WS_EX_TOOLWINDOW
        AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)
        w = rc.right - rc.left: h = rc.bottom - rc.top
        hWnd = CreateWindowEx(dwExStyle, zClass, "Find Record", dwStyle, 0, 0, w, h, hParent, 0, gP.hInstance, byval %NULL)
        if (hWnd) then
            '// Add the controls
            hCtrl = addLabel(hWnd, -1, "Find &Text:", dpi(3), dpi(30), dpi(55), dpi(16), %WS_CHILD or %WS_VISIBLE or %SS_RIGHT)
            hCtrl = addTextBox(hWnd, %ID_FIND, gP.findtext, dpi(61), dpi(26), dpi(154), dpi(22), %WS_CHILD or %WS_VISIBLE or %WS_TABSTOP or %ES_AUTOHSCROLL)
            SetFocus(hCtrl)
            dwStyle = %WS_CHILD or %WS_VISIBLE or %WS_TABSTOP
            hCtrl = addButton(hWnd, %IDOK, "&Find Next", dpi(86), dpi(76), dpi(60), dpi(23), dwStyle)
            hCtrl = addButton(hWnd, %IDCANCEL, "&Cancel", dpi(155), dpi(76), dpi(60), dpi(23), dwStyle)
           
            '// Center the child popup in the parent window.
            GetWindowRect(hParent, rw): nWidth = rw.right - rw.left: nHeight = rw.bottom - rw.top
            getWindowRect(hWnd, rc): w = rc.right - rc.left: h = rc.bottom - rc.top
            x = rw.left + ((nWidth - w) \ 2)
            y = rw.top + ((nHeight - h) \ 2)
            MoveWindow(hWnd, x, y, w, h, 0)
           
            EnableWindow(hParent, 0) '// Disable the parent to make it a modal tool window, see also WM_DESTROY 
            ShowWindow(hWnd, %SW_SHOW)
           
            while GetMessage(msg, %NULL, 0, 0)
                if (IsDialogMessage(hWnd, msg) = 0) then
                    TranslateMessage(msg)
                    DispatchMessage(msg)
                end if
            wend

            BringWindowToTop(hParent)
            function = msg.wParam
        end if
    end if
end function

sub ShowButtons(byval hWnd as dword, byval Visibility as long)
    local K as long
    for K = %ID_PRIOR to %ID_PRINT
        ShowWindow(GetDlgItem(hWnd, K), Visibility)
    next
    ShowWindow(GetDlgItem(hWnd, %IDCANCEL), Visibility)
end sub

function PrintThisWindow(BYVAL hWnd as dword) AS LONG
    local szBuffer as asciiz * %MAX_PATH
    local hDCprint as dword
    local nRet as long
    if (GetDefaultPrinter(szBuffer, %MAX_PATH)) then
        hDCprint = CreateDC(byval %NULL, szBuffer, byval %NULL, byval %NULL)
        if (hDCprint) then
            local rc as RECT
            local dinfo as DOCINFO
            local K, xtop, ytop, fxSize, fySize, hRes, vRes, offsetX, offsetY as long
            local rCoef as single
            local hDC, hScreenDC, hBmp as dword

            hRes  = GetDeviceCaps(hDCprint, %HORZRES)
            vRes  = GetDeviceCaps(hDCprint, %VERTRES)

            offsetX = 15: offsetY = 60
            GetClientRect(hWnd, rc)

            hScreenDC = GetDC(0)
            hDC = CreateCompatibleDC(hScreenDC)
            hBmp = CreateCompatibleBitmap(hScreenDC, rc.right, rc.bottom)
            SelectObject(hDC, hBmp)

            '// Hide the buttons
            ShowButtons(hWnd, %SW_HIDE)
            '// Windows do the WM_PRINTCLIENT for us
            PrintWindow(hWnd, hDC, %PW_CLIENTONLY)
            '// Show the buttons
            ShowButtons(hWnd, %SW_SHOW)

            rCoef = MIN((hRes - (offsetX * 2)) / rc.right, (vRes - (offsetY * 2)) / rc.bottom)
            fxSize = CLNG(rc.right * rCoef)
            fySize = CLNG(rc.bottom * rCoef)
            xtop = (hRes - fxSize) \ 2 + offsetX
            ytop = (vRes - fySize) \ 2 + offsetY

            dinfo.cbSize = sizeof(dinfo)
            dinfo.lpszDocName = %NULL
            dinfo.lpszOutput = %NULL
            if (StartDoc(hDCprint, dinfo) > 0) then
                if (StartPage(hDCprint) > 0) then

                    '// Paint the bitmap
                    if (hBmp) then

                        local bm as BITMAP, bi as BITMAPINFO
                        local dcBitmap, nBufSize, ghnd, gptr as dword

                        dcBitmap = CreateCompatibleDC(0)

                        GetObject(hBmp, sizeof(bm), bm)
                        bi.bmiHeader.biSize = sizeof(bi.bmiHeader)
                        bi.bmiHeader.biWidth = bm.bmWidth
                        bi.bmiHeader.biHeight = bm.bmHeight
                        bi.bmiHeader.biPlanes = 1
                        bi.bmiHeader.biBitCount = bm.bmBitsPixel
                        bi.bmiHeader.biCompression = %BI_RGB

                        '// Calculate space needed for the dib bits
                        nBufSize = (bm.bmWidth + 1) * (bm.bmBitsPixel / 8)
                        nBufSize = ((nBufSize + 3) / 4) * 4
                        nBufSize = nBufSize * bm.bmHeight

                        ghnd = GlobalAlloc(%GMEM_MOVEABLE, nBufSize)
                        gptr = GlobalLock(ghnd)

                        if (GetDIBits(dcBitmap, hBmp, 0, bm.bmHeight, BYVAL gptr, bi, 0)) then
                            nRet = StretchDIBits(hDCprint, xtop, ytop, fxSize, fySize, 0, 0, _
                                                 bm.bmWidth, bm.bmHeight, byval gptr, bi, 0, %SRCCOPY)
                        end if

                        GlobalUnlock(ghnd)
                        GlobalFree(ghnd)
                        DeleteDC(dcBitmap)

                    end if

                    if (EndPage(hDCprint) > 0) then
                        EndDoc(hDCprint)
                    end if
                end if
            end if

            '// Release
            DeleteDC(hDC)
            DeleteObject(hBmp)
            ReleaseDC(0, hScreenDC)

            DeleteDC(hDCprint)
        end if
    end if
    function = nRet
end function

function WndProc(byval hWnd as dword, byval uMsg as dword, byval wParam as long, byval lParam as long) as long

    static hFocus as dword

    select case long (uMsg)

    case %WM_NCACTIVATE
         '// Save the handle of the control that has the focus
         if (wParam = 0) then hFocus = GetFocus()

    case %WM_SETFOCUS
         '// Post a message to set the focus later, since some
         '// Windows actions can steal it if we set it here
         if (hFocus) then
            PostMessage(hWnd, %WM_APPLYFOCUS, hFocus, 0)
            hFocus = 0
         end if

    case %WM_APPLYFOCUS
         '// Set the focus
         if (wParam) then SetFocus(wParam)
         exit function

    case %WM_COMMAND
         if hi(word, wParam) = %EN_UPDATE _   '// Any edit control was changed
            or (lo(word, wParam) = %ID_COUNTRY and hi(word, wParam) = %CBN_SELCHANGE) then   '// The country combobox was changed
            '// if this is the first "change" message, we need to update the controls in the dialog box.
            if (gP.isrecmodified = 0) then
                gP.isrecmodified = %TRUE
                SetButtonStatus(hWnd)
            end if
         end if

         '// Messages from controls and menu items are handled here.
         select case long lo(word, wParam)
         case %IDCANCEL
              '// if the Escape key has been pressed...
              if hi(word, wParam) = %BN_CLICKED then
                  '// Shut down the application by sending a WM_CLOSE message
                 SendMessage(hWnd, %WM_CLOSE, 0, 0)
                 exit function
              end if

         case %ID_PRIOR
              gP.currententry = MAX&(gP.currententry - 1, 1)
              '// Disregard any existing editing if one of these button clicked
              gP.isrecmodified = %FALSE
              '// Update the dialog
              UdtToDialog(hWnd, gP.currententry)
              '// Update the Prior/Next control button status
              SetButtonStatus(hWnd)
              exit function
         case %ID_NEXT
              gP.currententry = min&(gP.currententry + 1, gP.maxentries)
              '// Disregard any existing editing if one of these button clicked
              gP.isrecmodified = %FALSE
              '// Update the dialog
              UdtToDialog(hWnd, gP.currententry)
              '// Update the Prior/Next control button status
              SetButtonStatus(hWnd)
              exit function
         case %ID_FIND
              FindDialog(hWnd)
              exit function
         case %ID_ADD, %ID_UPDATE
              AddUpdateRecord(hWnd, wParam)
              exit function
         case %ID_DELETE
              DeleteRecord(hWnd)
              exit function
         case %ID_PRINT
              if (PrintThisWindow(hWnd)) then
                  MessageBox(hWnd, $CRLF + "Address printed successfully.", "Info", %MB_ICONINFORMATION)
              else
                  MessageBox(hWnd, $CRLF + "Unable to print this address.", "Printer error", %MB_ICONEXCLAMATION)
              end if
              exit function
         case %ID_MENU_HELP
              MessageBox(hWnd, "Help not implemented", "Info", %MB_ICONINFORMATION)
              exit function
         case %ID_MENU_ABOUT
              MessageBox(hWnd, $crlf + "Address Book by PowerBASIC, Inc." + $crlf + $crlf + "SDK translation by Patrice Terrier.", "Address Book", %MB_ICONINFORMATION)
              exit function
         end select

    case %WM_DESTROY
         PostQuitMessage(0)
         exit function

    end select

    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

function WinMain (byval hInstance as dword, byval hPrevInstance as dword, byval lpszCmdLine as asciiz ptr, byval nCmdShow as long) as long
    local hWnd as dword, hCtrl as dword
    local wcx as WNDCLASSEX
    local szClassName as asciiz * 80, szFilename as asciiz * %MAX_PATH
    local dwStyle, dwLabelStyle, dwEditStyle, BufferSize, hFile, ByttesReaded, BytesWritten as dword
    local x, y, w, h, K, IsInitialized as long
    local msg as tagMSG

    gP.usefont = GetStockObject(%DEFAULT_GUI_FONT) '// Tahoma
    gP.hinstance = hInstance

    dim gAddressBook(1 to 1) as global AddressType
    szFilename = "ADDRESS.DAT"
    BufferSize = FileSize(szFilename)
    if (BufferSize) then
        gP.currententry = 1
        gP.maxentries = BufferSize \ sizeof(AddressType)
        redim gAddressBook(1 to gP.maxentries) as global AddressType
        hFile = CreateFile(szFilename, %GENERIC_READ, 0, byval %NULL, %OPEN_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
        if (hFile <> %INVALID_HANDLE_VALUE) then
            ReadFile(hFile, byval varptr(gAddressBook(1)), BufferSize, ByttesReaded, byval %NULL)
            CloseHandle(hFile)
        end if
    end if

    szClassName       = "SDKADDRESS"
    wcx.cbSize = sizeof(wcx)
    IsInitialized = GetClassInfoEx(hInstance, szClassName, wcx)
    if (IsInitialized     = 0) then
        wcx.style         = %CS_HREDRAW or %CS_VREDRAW
        wcx.lpfnWndProc   = codeptr(WndProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = hInstance
        wcx.hIcon         = LoadIcon  (%NULL, byval %IDI_APPLICATION)
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %COLOR_BTNSHADOW
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = VARPTR(szClassName)
        wcx.hIconSm       = LoadIcon  (%NULL, byval %IDI_APPLICATION)
        if (RegisterClassEx(wcx)) then IsInitialized = %TRUE
    end if
    if (IsInitialized) then
        w = dpi(606): x = (GetSystemMetrics(%SM_CXSCREEN) - w) / 2
        h = dpi(462): y = (GetSystemMetrics(%SM_CYSCREEN) - h) / 2
        hWnd = CreateWindowEx(%WS_EX_CONTROLPARENT or %WS_EX_WINDOWEDGE, szClassName, "Address Book - flat API SDK version", _
                    %WS_CLIPSIBLINGS or %WS_CAPTION or %WS_SYSMENU or _
                    %DS_3DLOOK or %DS_NOFAILCREATE or %DS_SETFONT or %DS_CENTER, _
                    x, y, w, h, 0, 0, hInstance, byval %NULL)
        if (hWnd) then
            dwLabelStyle = %WS_CHILD or %WS_VISIBLE or %SS_RIGHT
            dwEditStyle = %WS_CHILD or %WS_VISIBLE or %WS_TABSTOP or %ES_AUTOHSCROLL

            hCtrl = addLabel(hWnd, -%ID_INDEX, "Record N", 455, 8, 90, 13, dwLabelStyle)
            hCtrl = addLabel(hWnd, %ID_INDEX, "0 / 0", 549, 7, 38, 16, %WS_CHILD or %WS_VISIBLE or %SS_SUNKEN or %SS_CENTER)

            hCtrl = addLabel(hWnd, - %ID_COMPANY, "Compan&y", 8, 31, 90, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_COMPANY, "", 102, 28, 485, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_LASTNAME, "Last Na&me", 8, 54, 90, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_LASTNAME, "", 102, 51, 225, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_FIRSTNAME, "Fi&rst", 329, 54, 27, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_FIRSTNAME, "", 362, 51, 225, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_ADDRESS1, "Addre&ss", 8, 78, 90, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_ADDRESS1, "", 102, 75, 485, 19, dwEditStyle)

            hCtrl = addTextBox(hWnd, %ID_ADDRESS2, "", 102, 99, 485, 19, dwEditStyle)
            hCtrl = addTextBox(hWnd, %ID_ADDRESS3, "", 102, 124, 485, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_CITYNAME, "Ci&ty", 8, 151, 90, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_CITYNAME, "", 102, 148, 174, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_STATENAME, "State/Pro&vince", 282, 151, 75, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_STATENAME, "", 362, 148, 67, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_ZIPCODE, "&Zip or Postal Code", 8, 177, 90, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_ZIPCODE, "", 102, 174, 60, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_COUNTRY, "Co&untry", 193, 177, 38, 13, dwLabelStyle)
            hCtrl = addComboBox(hWnd, %ID_COUNTRY, "", 235, 174, 194, 170, %WS_CHILD or %WS_VISIBLE or %WS_TABSTOP or %WS_VSCROLL or %CBS_DROPDOWNLIST or %CBS_HASSTRINGS or %CBS_NOINTEGRALHEIGHT)
            AddCountries(hCtrl)

            hCtrl = addLabel(hWnd, - %ID_PHONE, "Ph&one", 8, 206, 90, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_PHONE, "", 102, 203, 225, 20, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_FAX, "Fa&x", 329, 206, 27, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_FAX, "", 362, 203, 225, 20, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_EMAIL, "Ema&il", 8, 234, 90, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_EMAIL, "", 102, 231, 225, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_URL, "&www", 331, 234, 27, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_URL, "", 362, 231, 225, 19, dwEditStyle)

            hCtrl = addLabel(hWnd, - %ID_COMMENTS, "C&omments", 8, 260, 90, 13, dwLabelStyle)
            hCtrl = addTextBox(hWnd, %ID_COMMENTS, "", 102, 257, 485, 105, dwEditStyle or %WS_VSCROLL or %ES_MULTILINE or %ES_WANTRETURN)

            dwStyle = %WS_CHILD or %WS_VISIBLE or %WS_TABSTOP
            hCtrl = addButton(hWnd, %ID_PRIOR,  "<<  &Prior",  16, 379, 60, 22, dwStyle)
            hCtrl = addButton(hWnd, %ID_NEXT,   "&Next  >>",   89, 379, 60, 22, dwStyle)
            hCtrl = addButton(hWnd, %ID_FIND,   "&Find",      162, 379, 60, 22, dwStyle)
            hCtrl = addButton(hWnd, %ID_ADD,    "&Add",       235, 379, 60, 22, dwStyle)
            hCtrl = addButton(hWnd, %ID_UPDATE, "U&pdate",    308, 379, 60, 22, dwStyle)
            hCtrl = addButton(hWnd, %ID_DELETE, "&Delete",    381, 379, 60, 22, dwStyle)
            hCtrl = addButton(hWnd, %ID_PRINT,  "&Print",     454, 379, 60, 22, dwStyle)
            hCtrl = addButton(hWnd, %IDCANCEL,  "&Close",     527, 379, 60, 22, dwStyle)
            SetButtonStatus(hWnd)

            local hMenu as dword, hPopMenu as dword
            hMenu = CreateMenu()
               hPopMenu = CreatePopUpMenu()
               AppendMenu(hMenu, %MF_POPUP, hPopMenu, "&File")
                  AppendMenu(hPopMenu, 0, 2, "&Close")
               hPopMenu = CreatePopUpMenu()
               AppendMenu(hMenu, %MF_POPUP, hPopMenu, "&Help")
                  AppendMenu(hPopMenu, 0, %ID_MENU_HELP, "&Help")
                  AppendMenu(hPopMenu, %MF_SEPARATOR, 0, "")
                  AppendMenu(hPopMenu, 0, %ID_MENU_ABOUT, "&About")
            SetMenu(hWnd, hMenu)

            UdtToDialog(hWnd, gP.currententry)
   
'            if (skInitEngine("Busi.sks", "")) then
'                skSkinWindow(hWnd, "Dock|Undock|Minimize|Maximize|Restore|Close")
'            end if

            ShowWindow(hWnd, nCmdShow)
            UpdateWindow(hWnd)

            while GetMessage(msg, %NULL, 0, 0)
                if (IsDialogMessage(hWnd, msg) = 0) then
                    TranslateMessage(msg)
                    DispatchMessage(msg)
                end if
            wend

            '// Save our data file if any changes were made
            if (gP.isfilemodified) then
                array sort gAddressBook(1) FOR gP.maxentries, _
                           from 1 to len(gAddressBook(1).Company + gAddressBook(1).LastName)
                hFile = CreateFile(szFilename, %GENERIC_WRITE, 0, byval %NULL, %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
                if (hFile <> %INVALID_HANDLE_VALUE) then
                    WriteFile(hFile, byval varptr(gAddressBook(1)), gP.maxentries * sizeof(AddressType), BytesWritten, byval %NULL)
                    CloseHandle(hFile)
                end if
            end if

            function = msg.wParam
        end if
    end if
end function


